package b4a.example;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class displaytree extends Activity implements B4AActivity{
	public static displaytree mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = true;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.displaytree");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (displaytree).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.displaytree");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.displaytree", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (displaytree) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (displaytree) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
//        try {
//            if (processBA.subExists("activity_actionbarhomeclick")) {
//                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
//                    getClass().getMethod("getActionBar").invoke(this), true);
//                BA.Log("adding event");
//            }
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
		return true;
	}   
// @Override
// public boolean onOptionsItemSelected(android.view.MenuItem item) {
//    if (item.getItemId() == 16908332) {
//        processBA.raiseEvent(null, "activity_actionbarhomeclick");
//        return true;
//    }
//    else
//        return super.onOptionsItemSelected(item); 
//}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return displaytree.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (displaytree) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (displaytree) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static int _node_height = 0;
public static int _node_width = 0;
public static int _node_margin_x = 0;
public static int _node_margin_y = 0;
public anywheresoftware.b4a.objects.collections.List _data = null;
public b4a.example.tree _datatree = null;
public anywheresoftware.b4a.objects.PanelWrapper _panel2 = null;
public anywheresoftware.b4a.agraham.gestures.Gestures _g1 = null;
public b4a.example.main _main = null;

public static void initializeProcessGlobals() {
             try {
                Class.forName(BA.applicationContext.getPackageName() + ".main").getMethod("initializeProcessGlobals").invoke(null, null);
            } catch (Exception e) {
                throw new RuntimeException(e);
            }
}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 25;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 30;BA.debugLine="Panel2.Initialize(\"Pnl\")";
mostCurrent._panel2.Initialize(mostCurrent.activityBA,"Pnl");
 //BA.debugLineNum = 31;BA.debugLine="Activity.AddView(Panel2,0%x,0%y,50%x,50%y)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._panel2.getObject()),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (0),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (0),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (50),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (50),mostCurrent.activityBA));
 //BA.debugLineNum = 32;BA.debugLine="Panel2.LoadLayout(\"Test\")";
mostCurrent._panel2.LoadLayout("Test",mostCurrent.activityBA);
 //BA.debugLineNum = 33;BA.debugLine="Data = GetData";
mostCurrent._data = _getdata();
 //BA.debugLineNum = 34;BA.debugLine="DataTree = GetRootTree(Data)";
mostCurrent._datatree = _getroottree(mostCurrent._data);
 //BA.debugLineNum = 35;BA.debugLine="CalculateControlSize(DataTree)";
_calculatecontrolsize(mostCurrent._datatree);
 //BA.debugLineNum = 36;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 42;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 44;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 38;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 40;BA.debugLine="End Sub";
return "";
}
public static String  _calculatecontrolsize(b4a.example.tree _node) throws Exception{
float _treewidth = 0f;
float _treeheight = 0f;
anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _bmp = null;
anywheresoftware.b4a.objects.drawable.CanvasWrapper _cvs = null;
b4a.example.pinchzoomandmove _pz = null;
int _c = 0;
 //BA.debugLineNum = 224;BA.debugLine="Sub CalculateControlSize(Node As Tree)";
 //BA.debugLineNum = 227;BA.debugLine="Dim treeWidth As Float = 14.65";
_treewidth = (float) (14.65);
 //BA.debugLineNum = 228;BA.debugLine="Dim treeHeight As Float = 3";
_treeheight = (float) (3);
 //BA.debugLineNum = 231;BA.debugLine="Dim bmp As Bitmap";
_bmp = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();
 //BA.debugLineNum = 234;BA.debugLine="Panel2.Height = treeHeight * Node_Height + (treeHeight + 1)* Node_Margin_Y";
mostCurrent._panel2.setHeight((int) (_treeheight*_node_height+(_treeheight+1)*_node_margin_y));
 //BA.debugLineNum = 235;BA.debugLine="Panel2.Width = treeWidth * Node_Width + (treeWidth + 1)* Node_Margin_X";
mostCurrent._panel2.setWidth((int) (_treewidth*_node_width+(_treewidth+1)*_node_margin_x));
 //BA.debugLineNum = 237;BA.debugLine="bmp.InitializeMutable(Panel2.Width,Panel2.Height)";
_bmp.InitializeMutable(mostCurrent._panel2.getWidth(),mostCurrent._panel2.getHeight());
 //BA.debugLineNum = 239;BA.debugLine="Dim Cvs As Canvas";
_cvs = new anywheresoftware.b4a.objects.drawable.CanvasWrapper();
 //BA.debugLineNum = 240;BA.debugLine="Cvs.Initialize(Panel2)";
_cvs.Initialize((android.view.View)(mostCurrent._panel2.getObject()));
 //BA.debugLineNum = 242;BA.debugLine="DrawNode(Node, Cvs, Panel2)";
_drawnode(_node,_cvs,mostCurrent._panel2);
 //BA.debugLineNum = 245;BA.debugLine="Panel2.Invalidate";
mostCurrent._panel2.Invalidate();
 //BA.debugLineNum = 246;BA.debugLine="Dim Pz As PinchZoomAndMove";
_pz = new b4a.example.pinchzoomandmove();
 //BA.debugLineNum = 247;BA.debugLine="Dim c As Int";
_c = 0;
 //BA.debugLineNum = 248;BA.debugLine="Pz.Initialize(Panel2,\"PZ\",c,0.5,5,20,False,Me)";
_pz._initialize(mostCurrent.activityBA,(anywheresoftware.b4a.objects.ConcreteViewWrapper) anywheresoftware.b4a.AbsObjectWrapper.ConvertToWrapper(new anywheresoftware.b4a.objects.ConcreteViewWrapper(), (android.view.View)(mostCurrent._panel2.getObject())),"PZ",(Object)(_c),(float) (0.5),(float) (5),(float) (20),anywheresoftware.b4a.keywords.Common.False,displaytree.getObject());
 //BA.debugLineNum = 252;BA.debugLine="End Sub";
return "";
}
public static String  _drawnode(b4a.example.tree _node,anywheresoftware.b4a.objects.drawable.CanvasWrapper _cvs,anywheresoftware.b4a.objects.PanelWrapper _parentpnl) throws Exception{
anywheresoftware.b4a.objects.drawable.CanvasWrapper.RectWrapper _noderect = null;
anywheresoftware.b4a.objects.drawable.CanvasWrapper.RectWrapper _imagerect = null;
anywheresoftware.b4a.objects.drawable.CanvasWrapper.RectWrapper _spouserect = null;
String _rectx = "";
String _recty = "";
String _text = "";
anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _image = null;
anywheresoftware.b4a.objects.ImageViewWrapper _imageview1 = null;
float _scale = 0f;
uk.co.martinpearman.b4a.touchimageview.TouchImageView _ti = null;
float _nodetopmiddle = 0f;
float _nodebottommiddlex = 0f;
float _nodebottommiddley = 0f;
b4a.example.tree _rightchild = null;
b4a.example.tree _leftchild = null;
float _linestartx = 0f;
float _linestarty = 0f;
float _lineendx = 0f;
float _lineendy = 0f;
Object _item = null;
 //BA.debugLineNum = 111;BA.debugLine="Sub DrawNode(Node As Tree, Cvs As Canvas, ParentPnl As Panel)";
 //BA.debugLineNum = 112;BA.debugLine="Dim NodeRect, ImageRect,SpouseRect As Rect";
_noderect = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.RectWrapper();
_imagerect = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.RectWrapper();
_spouserect = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.RectWrapper();
 //BA.debugLineNum = 113;BA.debugLine="Dim Rectx, RectY";
_rectx = "";
_recty = "";
 //BA.debugLineNum = 114;BA.debugLine="Dim Text As String";
_text = "";
 //BA.debugLineNum = 115;BA.debugLine="Dim Image As Bitmap";
_image = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();
 //BA.debugLineNum = 116;BA.debugLine="Dim ImageView1 As ImageView";
_imageview1 = new anywheresoftware.b4a.objects.ImageViewWrapper();
 //BA.debugLineNum = 117;BA.debugLine="Dim Scale As Float = GetDeviceLayoutValues.Scale";
_scale = anywheresoftware.b4a.keywords.Common.GetDeviceLayoutValues(mostCurrent.activityBA).Scale;
 //BA.debugLineNum = 120;BA.debugLine="Dim TI As TouchImageView";
_ti = new uk.co.martinpearman.b4a.touchimageview.TouchImageView();
 //BA.debugLineNum = 121;BA.debugLine="TI.Initialize(\"TView1\")";
_ti.Initialize(mostCurrent.activityBA,"TView1");
 //BA.debugLineNum = 122;BA.debugLine="TI.TouchEnabled= False";
_ti.setTouchEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 124;BA.debugLine="Image.Initialize(File.DirAssets,\"sallu.gif\")";
_image.Initialize(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"sallu.gif");
 //BA.debugLineNum = 125;BA.debugLine="ImageView1.Initialize(\"Click\")";
_imageview1.Initialize(mostCurrent.activityBA,"Click");
 //BA.debugLineNum = 126;BA.debugLine="ImageView1.Bitmap = Image";
_imageview1.setBitmap((android.graphics.Bitmap)(_image.getObject()));
 //BA.debugLineNum = 127;BA.debugLine="ImageView1.SendToBack";
_imageview1.SendToBack();
 //BA.debugLineNum = 128;BA.debugLine="Rectx = Node_Margin_X + (Node.X * (Node_Width + Node_Margin_X))";
_rectx = BA.NumberToString(_node_margin_x+(_node._x*(_node_width+_node_margin_x)));
 //BA.debugLineNum = 129;BA.debugLine="RectY = Node_Margin_Y + (Node.Y * (Node_Height + Node_Margin_Y))";
_recty = BA.NumberToString(_node_margin_y+(_node._y*(_node_height+_node_margin_y)));
 //BA.debugLineNum = 130;BA.debugLine="Node.X1 = Rectx";
_node._x1 = (float)(Double.parseDouble(_rectx));
 //BA.debugLineNum = 131;BA.debugLine="Node.Y1 = RectY";
_node._y1 = (float)(Double.parseDouble(_recty));
 //BA.debugLineNum = 132;BA.debugLine="If Node.HasSpouse Then";
if (_node._hasspouse()) { 
 //BA.debugLineNum = 133;BA.debugLine="Node.SpouseX1 = Rectx-Node_Width";
_node._spousex1 = (float) ((double)(Double.parseDouble(_rectx))-_node_width);
 //BA.debugLineNum = 134;BA.debugLine="Node.SpouseY1 = RectY";
_node._spousey1 = (float)(Double.parseDouble(_recty));
 //BA.debugLineNum = 135;BA.debugLine="Node.SpouseX2 = Rectx";
_node._spousex2 = (float)(Double.parseDouble(_rectx));
 //BA.debugLineNum = 136;BA.debugLine="Node.SpouseY2 = RectY + Node_Height";
_node._spousey2 = (float) ((double)(Double.parseDouble(_recty))+_node_height);
 //BA.debugLineNum = 137;BA.debugLine="SpouseRect.Initialize(Node.SpouseX1, Node.SpouseY1 ,Node.SpouseX2, Node.SpouseY2)";
_spouserect.Initialize((int) (_node._spousex1),(int) (_node._spousey1),(int) (_node._spousex2),(int) (_node._spousey2));
 //BA.debugLineNum = 139;BA.debugLine="Node.SpouseX1 = Scale * Node.SpouseX1";
_node._spousex1 = (float) (_scale*_node._spousex1);
 //BA.debugLineNum = 140;BA.debugLine="Node.SpouseY1 = Scale * Node.SpouseY1";
_node._spousey1 = (float) (_scale*_node._spousey1);
 //BA.debugLineNum = 141;BA.debugLine="Node.SpouseX2 = Scale * Node.SpouseX2";
_node._spousex2 = (float) (_scale*_node._spousex2);
 //BA.debugLineNum = 142;BA.debugLine="Node.SpouseY2 = Scale * Node.SpouseY2";
_node._spousey2 = (float) (_scale*_node._spousey2);
 //BA.debugLineNum = 143;BA.debugLine="Cvs.DrawRect(SpouseRect, Colors.White,False, 1dip)";
_cvs.DrawRect((android.graphics.Rect)(_spouserect.getObject()),anywheresoftware.b4a.keywords.Common.Colors.White,anywheresoftware.b4a.keywords.Common.False,(float) (anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (1))));
 };
 //BA.debugLineNum = 145;BA.debugLine="Node.X2 = Rectx + Node_Width";
_node._x2 = (float) ((double)(Double.parseDouble(_rectx))+_node_width);
 //BA.debugLineNum = 146;BA.debugLine="Node.Y2 = RectY + Node_Height";
_node._y2 = (float) ((double)(Double.parseDouble(_recty))+_node_height);
 //BA.debugLineNum = 147;BA.debugLine="NodeRect.Initialize(Node.X1, Node.Y1, Node.X2, Node.Y2)";
_noderect.Initialize((int) (_node._x1),(int) (_node._y1),(int) (_node._x2),(int) (_node._y2));
 //BA.debugLineNum = 150;BA.debugLine="ParentPnl.AddView(TI,Node.X1,Node.Y1,Node.X2 - Node.X1,Node.Y2 - Node.Y1)";
_parentpnl.AddView((android.view.View)(_ti.getObject()),(int) (_node._x1),(int) (_node._y1),(int) (_node._x2-_node._x1),(int) (_node._y2-_node._y1));
 //BA.debugLineNum = 152;BA.debugLine="TI.Bitmap = Image";
_ti.setBitmap((android.graphics.Bitmap)(_image.getObject()));
 //BA.debugLineNum = 153;BA.debugLine="TI.SetScaleRect(NodeRect,\"CENTER\")";
_ti.SetScaleRect((android.graphics.Rect)(_noderect.getObject()),"CENTER");
 //BA.debugLineNum = 157;BA.debugLine="Node.X1 = Scale * Node.X1";
_node._x1 = (float) (_scale*_node._x1);
 //BA.debugLineNum = 158;BA.debugLine="Node.Y1 = Scale * Node.Y1";
_node._y1 = (float) (_scale*_node._y1);
 //BA.debugLineNum = 159;BA.debugLine="Node.X2 = Scale * Node.X2";
_node._x2 = (float) (_scale*_node._x2);
 //BA.debugLineNum = 160;BA.debugLine="Node.Y2 = Scale * Node.Y2";
_node._y2 = (float) (_scale*_node._y2);
 //BA.debugLineNum = 163;BA.debugLine="Cvs.DrawRect(NodeRect, Colors.Gray,False, 1dip)";
_cvs.DrawRect((android.graphics.Rect)(_noderect.getObject()),anywheresoftware.b4a.keywords.Common.Colors.Gray,anywheresoftware.b4a.keywords.Common.False,(float) (anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (1))));
 //BA.debugLineNum = 168;BA.debugLine="Text = NumberFormat(Node.X,0,2)";
_text = anywheresoftware.b4a.keywords.Common.NumberFormat(_node._x,(int) (0),(int) (2));
 //BA.debugLineNum = 169;BA.debugLine="Cvs.DrawText(Node.ID, NodeRect.Left + 6, NodeRect.Top + 40,Typeface.DEFAULT,8, Colors.Yellow,\"LEFT\")";
_cvs.DrawText(mostCurrent.activityBA,_node._id,(float) (_noderect.getLeft()+6),(float) (_noderect.getTop()+40),anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT,(float) (8),anywheresoftware.b4a.keywords.Common.Colors.Yellow,BA.getEnumFromString(android.graphics.Paint.Align.class,"LEFT"));
 //BA.debugLineNum = 170;BA.debugLine="Cvs.DrawText(Text, NodeRect.Left + 4, NodeRect.Top + 70,Typeface.DEFAULT,8, Colors.Yellow,\"LEFT\")";
_cvs.DrawText(mostCurrent.activityBA,_text,(float) (_noderect.getLeft()+4),(float) (_noderect.getTop()+70),anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT,(float) (8),anywheresoftware.b4a.keywords.Common.Colors.Yellow,BA.getEnumFromString(android.graphics.Paint.Align.class,"LEFT"));
 //BA.debugLineNum = 173;BA.debugLine="If Node.Parent <> Null Then";
if (_node._parent!= null) { 
 //BA.debugLineNum = 174;BA.debugLine="Dim nodeTopMiddle As Float '= NodeRect.Left + (NodeRect.Right - NodeRect.Left) / 2";
_nodetopmiddle = 0f;
 //BA.debugLineNum = 175;BA.debugLine="If Node.HasSpouse Then";
if (_node._hasspouse()) { 
 //BA.debugLineNum = 176;BA.debugLine="nodeTopMiddle = SpouseRect.Left + (SpouseRect.Right - SpouseRect.Left) / 2";
_nodetopmiddle = (float) (_spouserect.getLeft()+(_spouserect.getRight()-_spouserect.getLeft())/(double)2);
 }else {
 //BA.debugLineNum = 178;BA.debugLine="nodeTopMiddle = NodeRect.Left + (NodeRect.Right - NodeRect.Left) / 2";
_nodetopmiddle = (float) (_noderect.getLeft()+(_noderect.getRight()-_noderect.getLeft())/(double)2);
 };
 //BA.debugLineNum = 180;BA.debugLine="Cvs.DrawLine(nodeTopMiddle,NodeRect.Top,nodeTopMiddle, NodeRect.Top - (Node_Margin_Y / 2),Colors.yellow,1dip)";
_cvs.DrawLine(_nodetopmiddle,(float) (_noderect.getTop()),_nodetopmiddle,(float) (_noderect.getTop()-(_node_margin_y/(double)2)),anywheresoftware.b4a.keywords.Common.Colors.Yellow,(float) (anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (1))));
 };
 //BA.debugLineNum = 184;BA.debugLine="If Node.Children.Size > 0 Then";
if (_node._children.getSize()>0) { 
 //BA.debugLineNum = 185;BA.debugLine="Dim nodeBottomMiddleX As Float = NodeRect.Left '+ (NodeRect.Right - NodeRect.Left) / 2";
_nodebottommiddlex = (float) (_noderect.getLeft());
 //BA.debugLineNum = 186;BA.debugLine="Dim nodeBottomMiddleY As Float = NodeRect.Top + NodeRect.Bottom - NodeRect.Top";
_nodebottommiddley = (float) (_noderect.getTop()+_noderect.getBottom()-_noderect.getTop());
 //BA.debugLineNum = 188;BA.debugLine="Cvs.DrawLine(nodeBottomMiddleX,nodeBottomMiddleY, nodeBottomMiddleX, nodeBottomMiddleY + (Node_Margin_Y/2),Colors.Red, 1dip)";
_cvs.DrawLine(_nodebottommiddlex,_nodebottommiddley,_nodebottommiddlex,(float) (_nodebottommiddley+(_node_margin_y/(double)2)),anywheresoftware.b4a.keywords.Common.Colors.Red,(float) (anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (1))));
 //BA.debugLineNum = 189;BA.debugLine="Dim RightChild, LeftChild As Tree";
_rightchild = new b4a.example.tree();
_leftchild = new b4a.example.tree();
 //BA.debugLineNum = 191;BA.debugLine="If Node.Children.Size = 1 Then";
if (_node._children.getSize()==1) { 
 //BA.debugLineNum = 192;BA.debugLine="LeftChild = Node.Children.Get(0)";
_leftchild = (b4a.example.tree)(_node._children.Get((int) (0)));
 //BA.debugLineNum = 193;BA.debugLine="If LeftChild.HasSpouse Then";
if (_leftchild._hasspouse()) { 
 //BA.debugLineNum = 194;BA.debugLine="Cvs.DrawLine(NodeRect.Left, NodeRect.Bottom + (Node_Margin_Y / 2) , SpouseRect.CenterX, NodeRect.Bottom + (Node_Margin_Y / 2),Colors.Green, 1Dip)";
_cvs.DrawLine((float) (_noderect.getLeft()),(float) (_noderect.getBottom()+(_node_margin_y/(double)2)),(float) (_spouserect.getCenterX()),(float) (_noderect.getBottom()+(_node_margin_y/(double)2)),anywheresoftware.b4a.keywords.Common.Colors.Green,(float) (anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (1))));
 }else {
 //BA.debugLineNum = 196;BA.debugLine="Cvs.DrawLine(NodeRect.Left, NodeRect.Bottom + (Node_Margin_Y / 2) , NodeRect.CenterX, NodeRect.Bottom + (Node_Margin_Y / 2),Colors.Green, 1Dip)";
_cvs.DrawLine((float) (_noderect.getLeft()),(float) (_noderect.getBottom()+(_node_margin_y/(double)2)),(float) (_noderect.getCenterX()),(float) (_noderect.getBottom()+(_node_margin_y/(double)2)),anywheresoftware.b4a.keywords.Common.Colors.Green,(float) (anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (1))));
 };
 }else if(_node._children.getSize()>1) { 
 //BA.debugLineNum = 200;BA.debugLine="Dim LineStartX, LineStartY, LineEndX, LineEndY As Float";
_linestartx = 0f;
_linestarty = 0f;
_lineendx = 0f;
_lineendy = 0f;
 //BA.debugLineNum = 202;BA.debugLine="LeftChild = Node.GetLeftMostChild";
_leftchild = _node._getleftmostchild();
 //BA.debugLineNum = 203;BA.debugLine="RightChild = Node.GetRightMostChild";
_rightchild = _node._getrightmostchild();
 //BA.debugLineNum = 204;BA.debugLine="LineStartX = Node_Margin_X + (Node.GetRightMostChild.X * (Node_Width + Node_Margin_X)) + (Node_Width / 2)";
_linestartx = (float) (_node_margin_x+(_node._getrightmostchild()._x*(_node_width+_node_margin_x))+(_node_width/(double)2));
 //BA.debugLineNum = 205;BA.debugLine="If RightChild.HasSpouse Then";
if (_rightchild._hasspouse()) { 
 //BA.debugLineNum = 206;BA.debugLine="LineStartX = LineStartX - Node_Width";
_linestartx = (float) (_linestartx-_node_width);
 };
 //BA.debugLineNum = 208;BA.debugLine="LineStartY = nodeBottomMiddleY + (Node_Margin_Y / 2)";
_linestarty = (float) (_nodebottommiddley+(_node_margin_y/(double)2));
 //BA.debugLineNum = 210;BA.debugLine="LineEndX = Node_Margin_X + (Node.GetLeftMostChild.X * (Node_Width + Node_Margin_X)) + (Node_Width / 2)";
_lineendx = (float) (_node_margin_x+(_node._getleftmostchild()._x*(_node_width+_node_margin_x))+(_node_width/(double)2));
 //BA.debugLineNum = 211;BA.debugLine="If LeftChild.HasSpouse Then";
if (_leftchild._hasspouse()) { 
 //BA.debugLineNum = 212;BA.debugLine="LineEndX = LineEndX - Node_Width";
_lineendx = (float) (_lineendx-_node_width);
 };
 //BA.debugLineNum = 214;BA.debugLine="LineEndY = nodeBottomMiddleY + (Node_Margin_Y / 2)";
_lineendy = (float) (_nodebottommiddley+(_node_margin_y/(double)2));
 //BA.debugLineNum = 216;BA.debugLine="Cvs.DrawLine(LineStartX,LineStartY,	LineEndX, LineEndY,Colors.Green, 1Dip)";
_cvs.DrawLine(_linestartx,_linestarty,_lineendx,_lineendy,anywheresoftware.b4a.keywords.Common.Colors.Green,(float) (anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (1))));
 };
 };
 //BA.debugLineNum = 220;BA.debugLine="For Each item In Node.Children";
final anywheresoftware.b4a.BA.IterableList group162 = _node._children;
final int groupLen162 = group162.getSize();
for (int index162 = 0;index162 < groupLen162 ;index162++){
_item = group162.Get(index162);
 //BA.debugLineNum = 221;BA.debugLine="DrawNode(item,Cvs,ParentPnl)";
_drawnode((b4a.example.tree)(_item),_cvs,_parentpnl);
 }
;
 //BA.debugLineNum = 223;BA.debugLine="End Sub";
return "";
}
public static anywheresoftware.b4a.objects.collections.List  _getchildren(anywheresoftware.b4a.objects.collections.List _tempdata,b4a.example.tree _parent) throws Exception{
String _id = "";
String _parentid = "";
String _name = "";
String _spouseid = "";
String[] _treevalues = null;
anywheresoftware.b4a.objects.collections.List _nodelist = null;
int _i = 0;
b4a.example.tree _treenode = null;
 //BA.debugLineNum = 81;BA.debugLine="Public Sub GetChildren(TempData As List, Parent As Tree) As List";
 //BA.debugLineNum = 82;BA.debugLine="Dim ID, ParentID, Name, SpouseID, TreeValues() As String";
_id = "";
_parentid = "";
_name = "";
_spouseid = "";
_treevalues = new String[(int) (0)];
java.util.Arrays.fill(_treevalues,"");
 //BA.debugLineNum = 83;BA.debugLine="Dim NodeList As List";
_nodelist = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 84;BA.debugLine="NodeList.Initialize";
_nodelist.Initialize();
 //BA.debugLineNum = 86;BA.debugLine="For i = 0 To TempData.Size - 1";
{
final int step60 = 1;
final int limit60 = (int) (_tempdata.getSize()-1);
for (_i = (int) (0); (step60 > 0 && _i <= limit60) || (step60 < 0 && _i >= limit60); _i = ((int)(0 + _i + step60))) {
 //BA.debugLineNum = 87;BA.debugLine="TreeValues = Regex.Split(\"~\",TempData.Get(i))";
_treevalues = anywheresoftware.b4a.keywords.Common.Regex.Split("~",BA.ObjectToString(_tempdata.Get(_i)));
 //BA.debugLineNum = 88;BA.debugLine="ID = TreeValues(0)";
_id = _treevalues[(int) (0)];
 //BA.debugLineNum = 89;BA.debugLine="ParentID = TreeValues(1)";
_parentid = _treevalues[(int) (1)];
 //BA.debugLineNum = 90;BA.debugLine="SpouseID = TreeValues(2)";
_spouseid = _treevalues[(int) (2)];
 //BA.debugLineNum = 91;BA.debugLine="Name = TreeValues(3)";
_name = _treevalues[(int) (3)];
 //BA.debugLineNum = 94;BA.debugLine="If ParentID = Parent.ID Then";
if ((_parentid).equals(_parent._id)) { 
 //BA.debugLineNum = 95;BA.debugLine="Dim TreeNode As Tree";
_treenode = new b4a.example.tree();
 //BA.debugLineNum = 97;BA.debugLine="TreeNode.Initialize(ID)";
_treenode._initialize(processBA,_id);
 //BA.debugLineNum = 99;BA.debugLine="TreeNode.AddParent (Parent)";
_treenode._addparent(_parent);
 //BA.debugLineNum = 101;BA.debugLine="TreeNode.Name = Name";
_treenode._name = _name;
 //BA.debugLineNum = 102;BA.debugLine="TreeNode.SpouseID = SpouseID";
_treenode._spouseid = _spouseid;
 //BA.debugLineNum = 103;BA.debugLine="TreeNode.X = TreeValues(4)";
_treenode._x = (float)(Double.parseDouble(_treevalues[(int) (4)]));
 //BA.debugLineNum = 104;BA.debugLine="TreeNode.Y = TreeValues(5)";
_treenode._y = (int)(Double.parseDouble(_treevalues[(int) (5)]));
 //BA.debugLineNum = 105;BA.debugLine="TreeNode.Children = GetChildren(TempData, TreeNode)";
_treenode._children = _getchildren(_tempdata,_treenode);
 //BA.debugLineNum = 106;BA.debugLine="NodeList.Add(TreeNode)";
_nodelist.Add((Object)(_treenode));
 };
 }
};
 //BA.debugLineNum = 109;BA.debugLine="Return NodeList";
if (true) return _nodelist;
 //BA.debugLineNum = 110;BA.debugLine="End Sub";
return null;
}
public static anywheresoftware.b4a.objects.collections.List  _getdata() throws Exception{
anywheresoftware.b4a.objects.collections.List _templist = null;
 //BA.debugLineNum = 45;BA.debugLine="Sub GetData() As List";
 //BA.debugLineNum = 46;BA.debugLine="Dim tempList As List";
_templist = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 47;BA.debugLine="tempList.Initialize";
_templist.Initialize();
 //BA.debugLineNum = 48;BA.debugLine="tempList.Add(\"1~~73~Pratapchand~9.05~0\")";
_templist.Add((Object)("1~~73~Pratapchand~9.05~0"));
 //BA.debugLineNum = 49;BA.debugLine="tempList.Add(\"2~1~74~Meghraj~4.45~1\")";
_templist.Add((Object)("2~1~74~Meghraj~4.45~1"));
 //BA.debugLineNum = 50;BA.debugLine="tempList.Add(\"3~1~75~Chunilal~6.75~1\")";
_templist.Add((Object)("3~1~75~Chunilal~6.75~1"));
 //BA.debugLineNum = 51;BA.debugLine="tempList.Add(\"4~1~76~Ghisulal~9.05~1\")";
_templist.Add((Object)("4~1~76~Ghisulal~9.05~1"));
 //BA.debugLineNum = 52;BA.debugLine="tempList.Add(\"5~1~77~Raichand~11.35~1\")";
_templist.Add((Object)("5~1~77~Raichand~11.35~1"));
 //BA.debugLineNum = 53;BA.debugLine="tempList.Add(\"6~1~78~Mohan~13.65~1\")";
_templist.Add((Object)("6~1~78~Mohan~13.65~1"));
 //BA.debugLineNum = 54;BA.debugLine="tempList.Add(\"7~2~79~Madan~1~2\")";
_templist.Add((Object)("7~2~79~Madan~1~2"));
 //BA.debugLineNum = 55;BA.debugLine="tempList.Add(\"8~2~80~Suresh~3.3~2\")";
_templist.Add((Object)("8~2~80~Suresh~3.3~2"));
 //BA.debugLineNum = 56;BA.debugLine="tempList.Add(\"9~2~81~Raju~5.6~2\")";
_templist.Add((Object)("9~2~81~Raju~5.6~2"));
 //BA.debugLineNum = 57;BA.debugLine="tempList.Add(\"10~2~82~Ashok~7.9~2\")";
_templist.Add((Object)("10~2~82~Ashok~7.9~2"));
 //BA.debugLineNum = 58;BA.debugLine="Return tempList";
if (true) return _templist;
 //BA.debugLineNum = 59;BA.debugLine="End Sub";
return null;
}
public static b4a.example.tree  _getroottree(anywheresoftware.b4a.objects.collections.List _tempdata) throws Exception{
String _id = "";
String _parentid = "";
String _name = "";
String _spouseid = "";
String[] _treevalues = null;
b4a.example.tree _root = null;
b4a.example.tree _parent = null;
 //BA.debugLineNum = 60;BA.debugLine="Sub GetRootTree(TempData As List) As Tree";
 //BA.debugLineNum = 61;BA.debugLine="Dim ID, ParentID, Name, SpouseID, TreeValues() As String";
_id = "";
_parentid = "";
_name = "";
_spouseid = "";
_treevalues = new String[(int) (0)];
java.util.Arrays.fill(_treevalues,"");
 //BA.debugLineNum = 62;BA.debugLine="Dim Root, Parent As Tree";
_root = new b4a.example.tree();
_parent = new b4a.example.tree();
 //BA.debugLineNum = 64;BA.debugLine="TreeValues = Regex.Split(\"~\",TempData.Get(0))";
_treevalues = anywheresoftware.b4a.keywords.Common.Regex.Split("~",BA.ObjectToString(_tempdata.Get((int) (0))));
 //BA.debugLineNum = 65;BA.debugLine="ID = TreeValues(0)";
_id = _treevalues[(int) (0)];
 //BA.debugLineNum = 66;BA.debugLine="ParentID = TreeValues(1)";
_parentid = _treevalues[(int) (1)];
 //BA.debugLineNum = 67;BA.debugLine="SpouseID = TreeValues(2)";
_spouseid = _treevalues[(int) (2)];
 //BA.debugLineNum = 68;BA.debugLine="Name = TreeValues(3)";
_name = _treevalues[(int) (3)];
 //BA.debugLineNum = 70;BA.debugLine="Root.Initialize(ID)";
_root._initialize(processBA,_id);
 //BA.debugLineNum = 71;BA.debugLine="Root.Name = Name";
_root._name = _name;
 //BA.debugLineNum = 72;BA.debugLine="Root.AddParent(Null)";
_root._addparent((b4a.example.tree)(anywheresoftware.b4a.keywords.Common.Null));
 //BA.debugLineNum = 73;BA.debugLine="Root.SpouseID = SpouseID";
_root._spouseid = _spouseid;
 //BA.debugLineNum = 74;BA.debugLine="Root.X = TreeValues(4)";
_root._x = (float)(Double.parseDouble(_treevalues[(int) (4)]));
 //BA.debugLineNum = 75;BA.debugLine="Root.Y = TreeValues(5)";
_root._y = (int)(Double.parseDouble(_treevalues[(int) (5)]));
 //BA.debugLineNum = 76;BA.debugLine="Root.AddChildren(GetChildren(TempData, Root))";
_root._addchildren(_getchildren(_tempdata,_root));
 //BA.debugLineNum = 78;BA.debugLine="Return Root";
if (true) return _root;
 //BA.debugLineNum = 80;BA.debugLine="End Sub";
return null;
}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 18;BA.debugLine="Dim Data As List";
mostCurrent._data = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 19;BA.debugLine="Dim DataTree As Tree";
mostCurrent._datatree = new b4a.example.tree();
 //BA.debugLineNum = 20;BA.debugLine="Dim Panel2 As Panel";
mostCurrent._panel2 = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 21;BA.debugLine="Dim g1 As Gestures";
mostCurrent._g1 = new anywheresoftware.b4a.agraham.gestures.Gestures();
 //BA.debugLineNum = 23;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 6;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 9;BA.debugLine="Private Node_Height As Int = 25dip";
_node_height = anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (25));
 //BA.debugLineNum = 10;BA.debugLine="Private Node_Width As Int = 15dip";
_node_width = anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (15));
 //BA.debugLineNum = 11;BA.debugLine="Private Node_Margin_X As Int = 3dip";
_node_margin_x = anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (3));
 //BA.debugLineNum = 12;BA.debugLine="Private Node_Margin_Y As Int = 20dip";
_node_margin_y = anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (20));
 //BA.debugLineNum = 13;BA.debugLine="End Sub";
return "";
}
public static String  _tview1_click() throws Exception{
 //BA.debugLineNum = 253;BA.debugLine="Sub TView1_Click";
 //BA.debugLineNum = 255;BA.debugLine="Log(\"TouchImageView1_Click\")";
anywheresoftware.b4a.keywords.Common.Log("TouchImageView1_Click");
 //BA.debugLineNum = 256;BA.debugLine="End Sub";
return "";
}
}
